<?php
	
	include '../ninja-controllers/cont.main.php';
	include 'functions.php'; 
	$view = isset($_GET['view']) ? $_GET['view'] : 'index';
	$app = isset($_GET['app']) ? $_GET['app'] : NULL;
	define('ADMIN_VALID', 1);

	if(!is_admin()){
		Header("Location: login.php");
	}
	if(filesize('../ninja-error.log') > 10000){
		file_put_contents('../ninja-error.log', '');
	}


?>
<!DOCTYPE html>
<html lang="en">
	<meta http-equiv="content-type" content="text/html;charset=UTF-8" />

	<head>
		<meta charset="utf-8">
		<title>PHPNinja - <?php echo strtoupper($view); ?></title>
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		<meta name="description" content="">
		<meta name="author" content="Huy Khong">

		<!-- Stylesheets -->
		<link href="assets/bootstrap/css/bootstrap.min.css" rel="stylesheet">
		<link href="assets/bootstrap/css/bootstrap-responsive.min.css" rel="stylesheet">
		<link href="assets/js/library/fullcalendar/fullcalendar.css" rel="stylesheet" type="text/css" />
		<link href="assets/css/styler/style.css" rel="stylesheet">
		<link href="assets/js/library/syntaxHighlighter/shCore.css" rel="stylesheet" type="text/css" />
		<link href="assets/js/library/syntaxHighlighter/shThemeDefault.css" rel="stylesheet" type="text/css" />
		<link rel="stylesheet" href="assets/css/styler/fontello.css">
		<link href="//netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css" rel="stylesheet">
	    <link rel="stylesheet" href="assets/css/styler/animation.css"><!--[if IE 7]>
	    <link rel="stylesheet" href="assets/css/styler/fontello-ie7.css"><![endif]-->
	    
		<!-- JS:jquery-->
		<script src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
		<script src="//ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/jquery-ui.min.js"></script>


		<!-- Custom Fonts -->
		<link href='http://fonts.googleapis.com/css?family=Roboto:400,700,300,500' rel='stylesheet' type='text/css'>
		<link href='http://fonts.googleapis.com/css?family=Montserrat:400,700' rel='stylesheet' type='text/css'>

		<!-- HTML5 shim, for IE6-8 support of HTML5 elements -->
		<!--[if lt IE 9]>
		  <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
		<![endif]-->
	</head>

  	<body cz-shortcut-listen="true">

  	<div class="navbar navbar-inverse navbar-fixed-top">
			<div class="navbar-inner">
				<div class="container-fluid">
					<button type="button" class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
						<span class="icon-menu"></span>
					</button>
					<a class="brand" href="index.php">PHPNinja DASHBOARD</a>
					<div class="nav-collapse collapse in">
						<ul class="nav">
							<li>
								<a href="<?php echo $ninja_config['siteUrl']; ?>"><i class="icon-home"></i> View your site</a>
							</li>
						</ul>		
						<ul class="nav pull-right">
							<li>
								<a href="logout.php"><span class="text-error"><i class="fa fa-power-off"></i> Log out</span></a>
							</li>
						</ul>		
					</div>
					<!--/.nav-collapse -->
				</div>
			</div>
	    </div>

	<section class="dashboard content">
		<div class="container-fluid">
				<div class="row-fluid">

					<div class="span3">

						<?php include 'view/sidebar.php'; ?>

					</div>

					<div class="span6">

							<?php
								if(isset($ninja_config['applications'])){
									foreach($ninja_config['applications'] as &$value){
										// INCLUDE MAIN CONTROLLERS
										if(file_exists(ROOT_DIR.'/ninja-applications/'.$value.'/install')){
										 echo '<div class="alert alert-error">
											    <button type="button" class="close" data-dismiss="alert">×</button>
											    <strong>Warning!</strong> You have enable application name <strong>'.$value.'</strong> but this application have not been installed yet.<br />
											    <strong><a href="'.$ninja_config['siteUrl'].'/ninja-applications/'.$value.'/install.php'.'">Click here to install.</a></strong>
											   </div>';
										}
									}
								}
							?>

						<?php 
							include isset($app) ? ROOT_DIR.'/ninja-applications/'.$app.'/acp/view/'.$view.'.php' : 'view/'.$view.'.php'; 
						?>

					</div>

					<div class="span3">

					<?php include ROOT_DIR.'/ninja-admin/view/task.php';?>

					</div>
					
				</div>
				
		</div>
	</section>


		<?php include 'layout/footer+js.php'; ?>
		
  	</body>

</html>

<?php
    $temp_limit = 31457280; // 30MB
    $temp_size = foldersize(ROOT_DIR.'/uploads/temp');
    if($temp_size > $temp_limit){
    	$files = glob(ROOT_DIR.'/uploads/temp'); // get all file names
		foreach($files as $file){ 
		  if(is_file($file))
		    unlink($file); // delete file
		}
    }

function foldersize($path) {
    $total_size = 0;
    $files = scandir($path);
    $cleanPath = rtrim($path, '/'). '/';

    foreach($files as $t) {
        if ($t<>"." && $t<>"..") {
            $currentFile = $cleanPath . $t;
            if (is_dir($currentFile)) {
                $size = foldersize($currentFile);
                $total_size += $size;
            }
            else {
                $size = filesize($currentFile);
                $total_size += $size;
            }
        }   
    }

    return $total_size;
}

?>