<?php

	include '../../../ninja-controllers/cont.main.php';
	include 'media_embed.php'; 
	include 'resize-class.php';

	function getYouTubeIdFromURL($url) {
		preg_match("/^(?:http(?:s)?:\/\/)?(?:www\.)?(?:youtu\.be\/|youtube\.com\/(?:(?:watch)?\?(?:.*&)?v(?:i)?=|(?:embed|v|vi|user)\/))([^\?&\"'>]+)/", $url, $matches);
	    return $matches[1];
	}

	$censorlist = json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/fufu/lib/sensorlist.inc'), true);
	$CurrentTime = new DateTime();

	$r = array(); // r mean return. This POST controllers will return an json with 'status' (ok for 1 and ko for 0) and 'message' for message. 
	
	if(!$ninja->isAdmin() && !isset($_POST['action'])){
		$r['status'] = 'ko';
		$r['message'] = 'Failed to pass security validations';
		echo json_encode($r);
		exit;
	}else{
		// ADD
		if(isset($_POST['action']) && $_POST['action'] == 'bulk'){
			if(!isset($_POST['type']) || $_POST['type'] == NULL){
				$r['status'] = 'ko';
				$r['message'] = 'Select a type<br />';
				echo json_encode($r);
				exit;
			}
				if($_POST['type'] == 'youtube'){
					// GET SOME INFORMATION

					$media = new media_embed(trim($_POST['url']));
					$site = $media->get_site();
					$id = getYouTubeIdFromURL(trim($_POST['url']));
					$xmlData = simplexml_load_string(file_get_contents("http://gdata.youtube.com/feeds/api/videos/".$id));
					$json = json_encode($xmlData);
					$array = json_decode($json,TRUE);
					$thisFu['original_img'] = $media->get_thumb("large");
					$headers = get_headers($thisFu['original_img'], 1); 
					$type = $headers["Content-Type"];
					$filetype = str_replace('/', '.', strstr($type, '/'));
					$resizeObj = new resize($thisFu['original_img']);
					$resizeObj -> resizeImage($fufu_config['thumb_width'], $fufu_config['thumb_height'], 'crop');

					$thisFu['thumbnail_img'] = '/uploads/fufu/'.uniqid('fu_').'.'.$filetype;
					$resizeObj -> saveImage(ROOT_DIR.$thisFu['thumbnail_img'], 100);
					$thisFu['iframe'] = $media->get_iframe('{{width}}','{{height}}');
					$thisFu['embed'] = $media->get_embed('{{width}}','{{height}}');
					$_POST['fu_type'] = 'video';
					$thisFu['title'] = $ninja->stritr(strip_tags(trim($array['title'])), $censorlist);

					$fu_info = array('title'=>$thisFu['title'],
									 'description'=>$ninja->stritr(strip_tags($array['content']), $censorlist),
									 'fu_type'=>'video',
									 'embed'=>$thisFu['embed'],
									 'iframe'=>$thisFu['iframe'],
									 'original_img'=>$thisFu['original_img'],
									 'thumbnail_img'=>$thisFu['thumbnail_img'],
									 'cat'=>$_POST['cat'],
									 'isapproved'=>'1',
									 'source'=>$ninja->stritr(strip_tags($_POST['source']), $censorlist),
									 'added'=>$CurrentTime->format('Y-m-d H:i:s'),
									 'poster_ip'=>$_SERVER['REMOTE_ADDR'], 
									);
					$ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."fufu_fu",$fu_info); 
					$slug = $ninja->slug($thisFu['title']);
					$fu_id = $ninja->db->last_insert_id;
					if($ninja->slugIsExist('/'.$slug) || $slug == '' || $slug == NULL){
						$slug .= '-'.$ninja->alphaID($fu_id);
					}
					$slug_info = array('c_id'=>$fu_id,
									   'slug'=>'/'.$slug,
									   'application'=>'fufu',
									   'page'=>'display_fu',
									   'important'=>'0');
					$ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."slug",$slug_info); 
					
					$r['status'] = 'ok';
					$r['message'] = '<br /><div class="alert alert-info">
			    	<button type="button" class="close" data-dismiss="alert">×</button>
			    	'.$array['title'].' successful added.
			    	</div>';
				}
		}
		echo json_encode($r);
		exit;
	}