<?php

	include '../../../ninja-controllers/cont.main.php';

	/* THIS FUNCTION IS ONLY FOR SITEMAP */
	function ninjaPing($sitemap_url, $ping){
		if(!isset($ping)){ return false; }
        $curl_req = array();
        $urls = array();

        if(in_array('google', $ping)){
        	$urls[] = "http://www.google.com/webmasters/tools/ping?sitemap=".urlencode($sitemap_url);
    	}
    	if(in_array('bing', $ping)){
        	$urls[] = "http://www.bing.com/webmaster/ping.aspx?siteMap=".urlencode($sitemap_url);
        }
        if(in_array('yahoo', $ping)){
        	$urls[] = "http://search.yahooapis.com/SiteExplorerService/V1/updateNotification?appid=YahooDemo&amp;url=".urlencode($sitemap_url);
        }
        if(in_array('ask', $ping)){
        	$urls[] = "http://submissions.ask.com/ping?sitemap=".urlencode($sitemap_url);
        }

        foreach ($urls as $url){
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $url);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURL_HTTP_VERSION_1_1, 1);
            $curl_req[] = $curl;
        }
        //initiating multi handler
        $multiHandle = curl_multi_init();
        // adding all the single handler to a multi handler
        foreach($curl_req as $key => $curl){
            curl_multi_add_handle($multiHandle,$curl);
        }
        $isactive = null;
        do{
            $multi_curl = curl_multi_exec($multiHandle, $isactive);
        }
        while ($isactive || $multi_curl == CURLM_CALL_MULTI_PERFORM );

        $success = true;
        foreach($curl_req as $curlO){
            if(curl_errno($curlO) != CURLE_OK){
                $success = false;
            }
        }
        curl_multi_close($multiHandle);
        return $success;
    }

	/* END SITEMAP FUNCTION */


	$r = array(); // r mean return. This POST controllers will return an json with 'status' (ok for 1 and ko for 0) and 'message' for message. 
	
	if(!$ninja->isAdmin() && !isset($_POST['action'])){
		$r['status'] = 'ko';
		$r['message'] = 'Failed to pass security validations';
		echo json_encode($r);
		exit;
	}else{
		// ADD
		if(isset($_POST['action']) && $_POST['action'] == 'generate'){
			$sitemap_header = '<?xml version="1.0" encoding="utf-8"?>
								<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
			$sitemap_footer = '</urlset>';

			/* INITIAL SITE MAP WITH HEADER */
			$sitemap = $sitemap_header;

			/* DEFAULT PAGE */
			$sitemap .= '<url>
								<loc>'.$ninja_config['siteUrl'].$fufu_slug['index'].'</loc>
								<priority>1.0</priority>
							</url>';	

			/* TYPE< */
			if(in_array('type', $_POST['included'])){
				$sitemap .= '<url>
								<loc>'.$ninja_config['siteUrl'].$fufu_slug['index'].'?type=video</loc>
								<priority>0.9</priority>
							</url>';
				$sitemap .= '<url>
								<loc>'.$ninja_config['siteUrl'].$fufu_slug['index'].'?type=gif</loc>
								<priority>0.9</priority>
							</url>';
				$sitemap .= '<url>
								<loc>'.$ninja_config['siteUrl'].$fufu_slug['index'].'?type=vine</loc>
								<priority>0.9</priority>
							</url>';
				$sitemap .= '<url>
								<loc>'.$ninja_config['siteUrl'].$fufu_slug['index'].'?type=img</loc>
								<priority>0.9</priority>
							</url>';
				$sitemap .= '<url>
								<loc>'.$ninja_config['siteUrl'].$fufu_slug['index'].'?type=soundcloud</loc>
								<priority>0.9</priority>
							</url>';
			}

			/* CATEGORY */
			if(in_array('category', $_POST['included'])){
				$ninja->db->order_by_column = "";
           		$ninja->db->limit_val="";
            	$cats = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."fufu_cat",array("name","cat_id")); 
            	if(count($cats) > 0){ 
					foreach($cats as &$cat){
						$sitemap .= '<url>
										<loc>'.$ninja_config['siteUrl'].$fufu_slug['index'].'?cat='.$cat['cat_id'].'</loc>
										<priority>0.9</priority>
									</url>';
					}
				}
			}

			/* MEDIA LINK< */
			if(in_array('media', $_POST['included'])){
				$ninja->db->order_by_column = "";
           		$ninja->db->limit_val="";
            	$medias = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."slug",array("slug"),array('page'=>'display_fu')); 
            	if(count($medias) > 0){ 
					foreach($medias as &$media){
						$sitemap .= '<url>
										<loc>'.$ninja_config['siteUrl'].$media['slug'].'</loc>
										<priority>0.8</priority>
									</url>';
					}
				}
			}			

			/* CUSTOM PAGE (BELONG TO FUFU APPLICATION ONLY) */
			if(in_array('custompage', $_POST['included'])){
				$ninja->db->order_by_column = "";
           		$ninja->db->limit_val="";
            	$pages = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."slug",array("slug"),array('page'=>'custom_pages','application'=>'fufu')); 
            	if(count($pages) > 0){ 
					foreach($pages as &$page){
						$sitemap .= '<url>
										<loc>'.$ninja_config['siteUrl'].$page['slug'].'</loc>
										<priority>0.8</priority>
									</url>';
					}
				}
			}

			/* SITE MAP FOOTER (FINAL STEP) */
			$sitemap .= $sitemap_footer;

			/* NOW REMOVE SPACE BETWEEN TAG< REDUCE SITEMAP SIZE*/
			$sitemap = preg_replace('~>\s+<~', '><', $sitemap);

			/* LOOK GOOD NOW< SAVE TO FILE! */
			file_put_contents(ROOT_DIR.'/'.$_POST['file'], $sitemap);

			$r['status'] = 'ok';
			$r['message'] = 'Sitemap generate finish'.(ninjaPing($ninja_config['siteUrl'].'/'.$_POST['file'], $_POST['ping']) ? ' and ping successful' : ' but not ping to SE yet');

		}
		echo json_encode($r);
		exit;
	}