<?php

	include '../../../ninja-controllers/cont.main.php';

	$r = array(); // r mean return. This POST controllers will return an json with 'status' (ok for 1 and ko for 0) and 'message' for message. 

	if(!isset($_POST['action'])){
		$r['status'] = 'ko';
		$r['message'] = 'Failed to pass security validations';
		echo json_encode($r);
		exit;
	}else if($_POST['action'] == 'edit'){
		/* CHECK THE FU's INFO FIRST< MAKE SURE IT'S OWNED BY THIS USER */
		$ninja->db->limit_val = '1';
		$result = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."fufu_fu","", array('f_id'=>$_POST['f_id'])); 
		if(count($result) < 1){
			/* CHECK IF THIS USER IS MEDIA OR NOT */
			$r['status'] = 'ko';
			$r['message'] = 'Failed to pass security validations';
			echo json_encode($r);
			exit;
		}else if(!isset($_POST['title']) || $_POST['title'] == NULL || strlen(trim($_POST['title'])) < $fufu_config['title_min'] || strlen(trim($_POST['title'])) > $fufu_config['title_max']){
			$r['status'] = 'ko';
			$r['message'] = sprintf($lang['fu-title-limit'], $fufu_config['title_min'], $fufu_config['title_max']);
			echo json_encode($r);
			exit;
		// VALIDATE THE DESCRIPTION	
		}else if(isset($_POST['description']) && strlen(trim($_POST['description'])) > $fufu_config['desc_max']){
			$r['status'] = 'ko';
			$r['message'] = sprintf($lang['fu-desc-limit'], $fufu_config['desc_max']);
			echo json_encode($r);
			exit;
		// VALIDATE THE CATEGORY	
		}else if($fufu_config['is_cat'] == 1){
			if(!isset($_POST['cat']) || !$ninja_fufu->cat_is_exist($_POST['cat'])){
				$r['status'] = 'ko';
				$r['message'] = $lang['Invalid-category'];
				echo json_encode($r);
				exit;
			}
		}
		if($result[0]['poster_id'] == $_SESSION['thisUser']['id'] OR $ninja->isAdmin()){
			$fu_info = array('title'=>strip_tags(trim($_POST['title'])),
							 'description'=>strip_tags(trim($_POST['description'])),
							 'source'=>$_POST['source'],
							 'cat'=>$_POST['cat'],
							 );
			/* DEACTIVE THIS FU IF "DEACTIVE AFTER EDIT" OPTION TURNED ON */
			if(isset($fufu_config['deactive_after_edit']) && $fufu_config['deactive_after_edit'] == '1'){ $fu_info = array_merge($fu_info, array('isapproved'=>'0')); }
			/* ALL FINE NOW, UPDATE DATABASE */
			$ninja->db->dbUpdate($ninja_config['TABLES_PREFIX']."fufu_fu",$fu_info,array('f_id'=>$_POST['f_id'])); 
			$r['status'] = 'ok';
			$r['message'] = 'Fu successful updated ';
			echo json_encode($r);
			exit;
		}
		$r['status'] = 'ko';
		$r['message'] = 'Failed to pass security validations';
		echo json_encode($r);
		exit;
	}else if($_POST['action'] == 'delete'){
		$slug_info = array('slug'=>$_POST['slug']);
		$fu_info = array('f_id'=>$_POST['f_id']);
		$ninja->db->limit_val = '1';
		$result = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."fufu_fu","",$fu_info); 
		if($result[0]['poster_id'] == $_SESSION['thisUser']['id'] OR $ninja->isAdmin()){
			/* CHECK IF THIS USER IS MEDIA OR NOT */
			$ninja->db->dbDelete($ninja_config['TABLES_PREFIX']."fufu_fu",$fu_info); 
			$ninja->db->dbDelete($ninja_config['TABLES_PREFIX']."slug",$slug_info); 
			if($result[0]['fu_type'] == 'img'){
				unlink(ROOT_DIR.$result[0]['original_img']);
				unlink(ROOT_DIR.$result[0]['thumbnail_img']);
			}else if($result[0]['fu_type'] == 'gif'){
				unlink(ROOT_DIR.$result[0]['original_img']);
				unlink(ROOT_DIR.$result[0]['thumbnail_img']);
				unlink(ROOT_DIR.$result[0]['embed']);
			}else{
				unlink(ROOT_DIR.$result[0]['thumbnail_img']);
			}
			$r['status'] = 'ok';
			$r['message'] = 'Fu successful deleted ';
			echo json_encode($r);
			exit;
		}
		$r['status'] = 'ko';
		$r['message'] = 'Failed to pass security validations';
		echo json_encode($r);
		exit;
	}else{
		$r['status'] = 'ko';
		$r['message'] = 'Fuuuuu, unknow issue!';
		echo json_encode($r);
		exit;
	}

