<?php

	include '../../../ninja-controllers/cont.main.php';
	include 'media_embed.php'; 
	include 'resize-class.php';
	include 'watermark.class.php';
	include 'embedder/function.php';
	
	sleep($fufu_config['post_delay']);

	/* INCLUDE CENSORLIST */
	$censorlist = json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/fufu/lib/sensorlist.inc'), true);

	/* INCLUDE EMBEDDER */
	$embedder = json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/fufu/lib/embedder.inc'), true);
	foreach($embedder['list'] as &$site){
		include 'embedder/'.($site).'.php'; 
	}

	$r = array(); // r mean return. This POST controllers will return an json with 'status' (ok for 1 and ko for 0) and 'message' for message. 
	if(!isset($_POST['cat']) || empty($_POST['cat'])){
		$_POST['cat'] = '0';
	}
	if (!file_exists(ROOT_DIR.'/uploads/fufu/'.$_POST['cat'])){
	    mkdir(ROOT_DIR.'/uploads/fufu/'.$_POST['cat'], 0777, true);
	}

	if(!isset($_POST['action'])){
		$r['status'] = 'ko';
		$r['message'] = 'Failed to pass security validations';
		echo json_encode($r);
		exit;
	}else if($_POST['action'] == 'add_fu'){

		if($fufu_config['is_wtm'] == '1'){
			$watermark_options			= array(
				'watermark' 	=> '../../..'.str_replace('{{siteUrl}}','', $fufu_config['wtm_image']),
				'halign'		=> $fufu_config['wtm_halign'],
				'valign'		=> $fufu_config['wtm_valign'],
				'hshift'		=> -10,						
				'vshift'		=> -10,						
				'type'			=> IMAGETYPE_JPEG,
				'jpeg-quality'	=> 90,
			);
		}

	// YEP > VALIDATION AND MORE
		$time2Check = new DateTime();
		$CurrentTime = new DateTime();
		$time2Check->modify('-'.$fufu_config['time_limit'].' minutes');
 		$ninja->db->limit_val="1";
   		$spamCheck = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."fufu_fu", array("f_id"),
   							array('poster_ip'=>$_SERVER['REMOTE_ADDR'],
   								  "added >="=>$time2Check->format('Y-m-d H:i:s'),
   								  "added <="=>$CurrentTime->format('Y-m-d H:i:s'))
   							); 
		// VALIDATE THE TITLE
		if(count($spamCheck) > 0){
			$r['status'] = 'ko';
			$r['message'] = sprintf($lang['time-limit-reach'], $fufu_config['time_limit']); 
	   		echo json_encode($r);
	   		exit;
   		}else if(!isset($_POST['title']) || $_POST['title'] == NULL || strlen(trim($_POST['title'])) < $fufu_config['title_min'] || strlen(trim($_POST['title'])) > $fufu_config['title_max']){
			$r['status'] = 'ko';
			$r['message'] = sprintf($lang['fu-title-limit'], $fufu_config['title_min'], $fufu_config['title_max']);
			echo json_encode($r);
			exit;
		// VALIDATE THE DESCRIPTION	
		}else if(isset($_POST['description']) && strlen(trim($_POST['description'])) > $fufu_config['desc_max']){
			$r['status'] = 'ko';
			$r['message'] = sprintf($lang['fu-desc-limit'], $fufu_config['desc_max']);
			echo json_encode($r);
			exit;
		// VALIDATE THE CATEGORY	
		}else if($fufu_config['is_cat'] == 1){
			if(!isset($_POST['cat']) || !$ninja_fufu->cat_is_exist($_POST['cat'])){
				$r['status'] = 'ko';
				$r['message'] = $lang['Invalid-category'];
				echo json_encode($r);
				exit;
			}
		}

	// ALL VALIDATION PASSED > PROGRESS WITH MEDIA
		// SOUNDCLOUD
		if(isset($_POST['soundcloud']) && $_POST['soundcloud'] != NULL && in_array('video', $fufu_config['fu_type'])){
			/* >>> CHECK IF SOUNDCLOUD URL */
			$var = parse_url(trim($_POST['soundcloud']));
			if (strpos($var['host'],'soundcloud.com') !== false) {
				$content = json_decode(substr(get_data('http://soundcloud.com/oembed?format=js&url='.$_POST['soundcloud'].'&iframe=true'), 1, -2), true);
				/* SAVE ORIGINAL IMAGE */
				$thisFu['original_img'] = '/uploads/fufu/'.$_POST['cat'].'/original_'.uniqid('fu_').'.jpg';
				grab_image($content['thumbnail_url'], ROOT_DIR.$thisFu['original_img']);
				/* RESIZE AND SAVE THUMBNAIL */
				$resizeObj = new resize(ROOT_DIR.$thisFu['original_img']);
				$resizeObj -> resizeImage($fufu_config['thumb_width'], $fufu_config['thumb_height'], 'crop');
				$thisFu['thumbnail_img'] = '/uploads/fufu/'.$_POST['cat'].'/'.uniqid('fu_').'.jpg';
				$resizeObj -> saveImage(ROOT_DIR.$thisFu['thumbnail_img'], 80);
				$thisFu['iframe'] = $content['html'];				
				$_POST['fu_type'] = 'soundcloud';
			}else{
			/* >>> FAIL IF NOT */
				$r['status'] = 'ko';
				$r['message'] = $lang['invalid-soundcloud-url'];
				echo json_encode($r);
				exit;
			}
		// VIDEO EMBEDDER
		}else if(isset($_POST['video-url']) && $_POST['video-url'] != NULL && in_array('video', $fufu_config['fu_type'])){
			/* >>> CHECK IF VIDEO URL MEET CUSTOM USER's EMBEDDER */
			foreach($e_sites as $site => $data){
				preg_match($data['regex'], $_POST['video-url'], $match);
				if(!empty($match)){
					for($i = 1; $i < sizeof($match); $i++){
						if($match[$i] != ""){
							/* IF 'code' is 1 => return match code, else return video url */
							$thisSite = $site;
							$code = $data['code'] == '1' ? $match[$i] : $_POST['video-url'];
							//echo 'code:{'.$code.'}';
							break;
						}
					}
				}
			}
			/* >>> IF NOT */
			if($code == null){
				/* >>> IF EMBED.LY API SET, LET SHOOT VIDEO URL TO EMBED.LY */
				if(isset($fufu_config['embedly_api'])){
					$thisVideo = json_decode(get_data('http://api.embed.ly/1/oembed?key='.$fufu_config['embedly_api'].'&url='.$_POST['video-url'].'&maxwidth=740'), TRUE);
					/* IS IT VIDEO OR NOT (EMBED.LY ALLOW PICTURE AND RICH CONTENT SO WE HAVE TO CHECK IT FIRST */
					if($thisVideo['type'] != 'video'){
						$r['status'] = 'ko';
						$r['message'] = $lang['invalid-video-url'];
						echo json_encode($r);
						exit;
					}else{
						/* KEEP ON IF SUPPORTED >>> FETCH DATA */
						$e_img = preg_replace('/\\?.*/', '', $thisVideo['thumbnail_url']);
						$e_html = strtr($thisVideo['html'], array('740'=>'{{width}}'));
						$thisFu['original_img'] = '/uploads/fufu/'.$_POST['cat'].'/original_'.uniqid('fu_').'.jpg';
						grab_image($e_img, ROOT_DIR.$thisFu['original_img']);
						/* RESIZE AND SAVE THUMBNAIL */
						$resizeObj = new resize(ROOT_DIR.$thisFu['original_img']);
						$resizeObj -> resizeImage($fufu_config['thumb_width'], $fufu_config['thumb_height'], 'crop');
						$thisFu['thumbnail_img'] = '/uploads/fufu/'.$_POST['cat'].'/'.uniqid('fu_').'.jpg';
						$resizeObj -> saveImage(ROOT_DIR.$thisFu['thumbnail_img'], 80);
						$thisFu['iframe'] = '<div class="video-container">'.$e_html.'</div>';				
						$_POST['fu_type'] = 'video';
					}
				}else{
					$r['status'] = 'ko';
					$r['message'] = $lang['invalid-video-url'];
					echo json_encode($r);
					exit;
				}
			}else{
				/* KEEP ON IF SUPPORTED >>> FETCH DATA */
				$e_img = ($thisSite)."_img";
				$e_html = ($thisSite)."_html";
				/* SAVE ORIGINAL IMAGE */
				$thisFu['original_img'] = '/uploads/fufu/'.$_POST['cat'].'/original_'.uniqid('fu_').'.jpg';
				grab_image($e_img($code), ROOT_DIR.$thisFu['original_img']);
				/* RESIZE AND SAVE THUMBNAIL */
				$resizeObj = new resize(ROOT_DIR.$thisFu['original_img']);
				$resizeObj -> resizeImage($fufu_config['thumb_width'], $fufu_config['thumb_height'], 'crop');
				$thisFu['thumbnail_img'] = '/uploads/fufu/'.$_POST['cat'].'/'.uniqid('fu_').'.jpg';
				$resizeObj -> saveImage(ROOT_DIR.$thisFu['thumbnail_img'], 80);
				$thisFu['iframe'] = $e_html($code);				
				$_POST['fu_type'] = 'video';
			}

		// IMAGE URL
		}else if(isset($_POST['img-url']) && $_POST['img-url'] != NULL && (in_array('image', $fufu_config['fu_type']) || in_array('gif', $fufu_config['fu_type'])) ){
			// CHECK IF THIS's AN IMAGE 
			$type = get_image_type($_POST['img-url']);
			$image_array = array('image/png','image/jpeg','image/bmp');
			if(in_array('gif', $fufu_config['fu_type'])){ array_push($image_array, 'image/gif'); }
			$filetype = str_replace('/', '.', strstr($type, '/'));
			// START CHECKING
			if(in_array($type, $image_array)){ 
				// ALLOW
				// SAVE THE IMAGE INTO OUR SERVER
					// IF GIF
					if($type != 'image/gif'){
						// SAVE ORIGINAL IMAGE
							$thisFu['original_img'] = '/uploads/fufu/'.$_POST['cat'].'/original_'.uniqid('fu_').'.jpg';
							grab_image($_POST['img-url'], ROOT_DIR.$thisFu['original_img']);
							/*$im = imagecreatefromjpeg(ROOT_DIR.$thisFu['original_img']);
							imageinterlace($im, true);
							imagegif($im, ROOT_DIR.$thisFu['original_img']);*/
							if($fufu_config['is_wtm'] == '1'){
								$thisFu['watermarked_img'] = '/uploads/fufu/'.$_POST['cat'].'/wtm_'.uniqid('fu_').'.jpg';
								Watermark::output('../../..'.$thisFu['original_img'], '../../..'.$thisFu['watermarked_img'], $watermark_options);
								unlink(ROOT_DIR.$thisFu['original_img']);
								$thisFu['original_img'] = $thisFu['watermarked_img'];
							}
						// SAVE THUMBNAIL IMAGE
							$resizeObj = new resize(ROOT_DIR.$thisFu['original_img']);
							$resizeObj -> resizeImage($fufu_config['thumb_width'], $fufu_config['thumb_height'], 'crop');
							$thisFu['thumbnail_img'] = '/uploads/fufu/'.$_POST['cat'].'/'.uniqid('fu_').'.jpg';
							$resizeObj -> saveImage(ROOT_DIR.$thisFu['thumbnail_img'], 100);
						// FINISH, RETURN FU_TYPE AND KEEP PROCESSING
							$_POST['fu_type'] = 'img';
					}else{
						// SAVE ORIGINAL IMAGE
							$thisFu['original_img'] = '/uploads/fufu/'.$_POST['cat'].'/original_'.uniqid('fu_').'.gif';
							grab_image($_POST['img-url'], ROOT_DIR.$thisFu['original_img']);
							$thisFu['embed'] = '/uploads/fufu/'.$_POST['cat'].'/original_'.uniqid('fu_').'.png';
							imagepng(imagecreatefromstring(file_get_contents(ROOT_DIR.$thisFu['original_img'])), ROOT_DIR.$thisFu['embed']);
							if($fufu_config['is_wtm_gif'] == '1'){
								$thisFu['watermarked_img'] = '/uploads/fufu/'.$_POST['cat'].'/wtm_'.uniqid('fu_').'.jpg';
								
								// ADD WATERMARK ON GIF 
									$animation = '../../..'.$thisFu['original_img'];
									$watermark = '../../..'.str_replace('{{siteUrl}}','', $fufu_config['wtm_image']);
									$watermarked_animation = '../../..'.$thisFu['watermarked_img'];
									$position = $fufu_config['wtm_gifpos'];
									$cmd = " $animation -coalesce -gravity $position ". 
									" -geometry +0+0 null: $watermark -layers composite -layers optimize "; 

									exec("convert $cmd $watermarked_animation "); 
								
								unlink(ROOT_DIR.$thisFu['original_img']);
								$thisFu['original_img'] = $thisFu['watermarked_img'];
							}
						// SAVE THUMBNAIL IMAGE
							$resizeObj = new resize(ROOT_DIR.$thisFu['original_img']);
							$resizeObj -> resizeImage($fufu_config['thumb_width'], $fufu_config['thumb_height'], 'crop');
							$thisFu['thumbnail_img'] = '/uploads/fufu/'.$_POST['cat'].'/'.uniqid('fu_').'.jpg';
							$resizeObj -> saveImage(ROOT_DIR.$thisFu['thumbnail_img'], 100);
						// FINISH, RETURN FU_TYPE AND KEEP PROCESSING
							$_POST['fu_type'] = 'gif';
					}
			}else{
				// FAIL
				$r['status'] = 'ko';
				$r['message'] = $lang['invalid-img-url'];
				echo json_encode($r);
				exit;
			}
		// VINE URL
		}else if(isset($_POST['vine-url']) && $_POST['vine-url'] != NULL && in_array('vine', $fufu_config['fu_type'])){
			if (stripos(trim($_POST['vine-url']), '//vine.co/v/') !== FALSE) {
				$thisFu['iframe'] = '<iframe class="vine-embed" src="'.$_POST['vine-url'].'/embed/simple?audio=0" width="{{width}}" height="{{height}}" frameborder="0"></iframe><script async src="//platform.vine.co/static/scripts/embed.js" charset="utf-8"></script>';
				$thisFu['original_img'] = '/uploads/fufu/'.$_POST['cat'].'/original_'.uniqid('fu_').'.jpg';
				grab_image($ninja_fufu->get_vine_thumbnail($_POST['vine-url']), ROOT_DIR.$thisFu['original_img']);
				$resizeObj = new resize(ROOT_DIR.$thisFu['original_img']);
				$resizeObj -> resizeImage($fufu_config['thumb_width'], $fufu_config['thumb_height'], 'crop');
				$thisFu['thumbnail_img'] = '/uploads/fufu/'.$_POST['cat'].'/'.uniqid('fu_').'.jpg';
				$resizeObj -> saveImage(ROOT_DIR.$thisFu['thumbnail_img'], 100);
				$_POST['fu_type'] = 'vine';
			}else{
				$r['status'] = 'ko';
				$r['message'] = $lang['invalid-vine-url'];
				echo json_encode($r);
				exit;
			}
		}else{
			$r['status'] = 'ko';
			$r['message'] = $lang['please-input-fu'];
			echo json_encode($r);
			exit;
		}

	// FU INFO AND INSERT FU
	$_POST['embed'] = isset($thisFu['embed']) ? $thisFu['embed'] : '';
	$_POST['iframe'] = isset($thisFu['iframe']) ? $thisFu['iframe'] : '';
	$original_img = isset($thisFu['original_img']) ? $thisFu['original_img'] : '';
	$thumbnail_img = isset($thisFu['thumbnail_img']) ? $thisFu['thumbnail_img'] : '';
	$_POST['isapproved'] = $fufu_config['is_approval'] == 1 ? '0' : '1';
	$poster = isset($_SESSION['thisUser']) ? $_SESSION['thisUser']['id'] : '';
	if(!isset($_POST['cat'])){ $_POST['cat'] = '0'; }

	// ADD POINT FOR USER IF FU APPROVAL TURNED OFF
	if(isset($_SESSION['thisUser']) && $fufu_config['is_approval'] != '1'){
		$ninja_fufu->add_point($_SESSION['thisUser']['id'],$fufu_user_config['fu_approved_point']);
	}

	// INSERT FU
	$fu_info = array('title'=>$ninja->stritr(strip_tags(trim($_POST['title'])), $censorlist),
						 'description'=>$ninja->stritr(strip_tags($_POST['description']), $censorlist),
						 'fu_type'=>$_POST['fu_type'],
						 'embed'=>$_POST['embed'],
						 'iframe'=>$_POST['iframe'],
						 'original_img'=>$original_img,
						 'thumbnail_img'=>$thumbnail_img,
						 'cat'=>$_POST['cat'],
						 'isapproved'=>$_POST['isapproved'],
						 'source'=>$ninja->stritr(strip_tags($_POST['source']), $censorlist),
						 'added'=>$CurrentTime->format('Y-m-d H:i:s'),
						 'poster_ip'=>$_SERVER['REMOTE_ADDR'],
						 'poster_id'=>$poster,
						);

	$ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."fufu_fu",$fu_info); 
	$fu_id = $ninja->db->last_insert_id;

	// INSERT SLUG
		if(isset($fufu_config['media_slug']) && $fufu_config['media_slug'] == '0'){
			$slug = $ninja->alphaID($fu_id);
		}else if(isset($fufu_config['media_slug']) && $fufu_config['media_slug'] == '1'){
			$slug = $ninja_fufu->gen_6slug();
		}else{
			$slug = $ninja->slug(strip_tags($ninja->stritr($ninja->ru2lat(strip_tags(trim($_POST['title']))), $censorlist)));
			if($ninja->slugIsExist('/'.$slug) || $slug == '' || $slug == NULL){
				$slug .= '-'.$ninja->alphaID($fu_id);
			}
		}

	$slug_info = array('c_id'=>$fu_id,
					   'slug'=>'/'.$slug,
					   'application'=>'fufu',
					   'page'=>'display_fu',
					   'important'=>'0');
	$ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."slug",$slug_info); 

	// INSERT POINT IF USER LOGGED IN
	

	$r['status'] = 'ok';
	$r['message'] = ($fufu_config['is_approval'] == '1') ? $lang['post-fu-success-waiting'] : html_entity_decode(sprintf($lang['post-fu-success-publised'], $ninja_config['siteUrl'].'/'.$slug)); 
	echo json_encode($r);
	exit;

	}else{
		$r['status'] = 'ko';
		$r['message'] = 'Fuuuuu, unknow issue!';
		echo json_encode($r);
		exit;
	}

