<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title><?php echo $fu_seo_setting['fuTitle']; ?></title>
    <meta name="description" content="<?php echo $fu_seo_setting['fuDescription'];?>">
    <meta name="keyword" content="<?php echo $fu_seo_setting['fuKeyword'];?>">
    <meta name="author" content="<?php echo $fu_seo_setting['author'];?>">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta property="og:title" content="<?php echo $fu_seo_setting['fuTitle'];?>"/>
    <meta property="og:image" content="<?php echo (preg_match("#https?://#", $thisFu['original_img']) === 0) ? $ninja_config['siteUrl'].$thisFu['original_img'] : $thisFu['original_img'];?>"/>
    <meta property="og:site_name" content="<?php echo $fu_seo_setting['hometitle'];?>"/>
    <meta property="og:description" content="<?php echo $thisFu['description'];?>"/>

    <?php include ROOT_DIR.'/ninja-applications/fufu/themes/default/layouts/head_tag.php'; ?>

  </head>
  <body>
    <div id="fb-root"></div>
    <script>(function(d, s, id) {
      var js, fjs = d.getElementsByTagName(s)[0];
      if (d.getElementById(id)) return;
      js = d.createElement(s); js.id = id;
      js.src = "//connect.facebook.net/en_US/all.js#xfbml=1&appId=<?php echo !isset($fufu_config['fb_id']) ? '342802565860349' : $fufu_config['fb_id'];?>";
      fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));</script>

    <?php include ROOT_DIR.'/ninja-applications/fufu/themes/default/layouts/log-reg.php'; ?>
    <?php include ROOT_DIR.'/ninja-applications/fufu/themes/default/layouts/navbar.php'; ?>

    <?php include ROOT_DIR.'/ninja-applications/fufu/themes/default/layouts/trending.php'; ?>

    <div class="container">

      <!-- Buttons
      ================================================== -->
      <div class="content">

        <div class="row">
          <div class="col-lg-8">

          	<?php
          		if(($ninja_user->isLoggedIn() AND $thisFu['poster_id'] == $_SESSION['thisUser']['id']) OR ($ninja->isAdmin())){ 
          			include 'layouts/edit_fu_modal.php'; 
          		}
          	?>

            <?php include 'layouts/post-fu-div.php'; ?>
            <?php include 'layouts/ads1.html'; ?>

            <?php 
                  $print_source = (filter_var($thisFu['source'], FILTER_VALIDATE_URL) === FALSE) ? '<i class="icon-info-circled-1"></i> '.$lang['Source'].': '.$thisFu['source'] : '<i class="icon-info-circled-1"></i> <a href="'.$thisFu['source'].'">'.$lang['Source'].'</a>';
            ?>
              <div class="panel panel-primary">
                <div class="panel-heading single-fu-heading">
                  <div class="row">
                    <div class="col-lg-2 col-sm-2 col-xs-2">
                    <?php if($thisOwner != NULL): ?> 
                      <a data-toggle="tooltip" data-placement="right" title="<?php echo $thisOwner['username'];?>" href="<?php echo $ninja_config['siteUrl'].$fufu_slug['index'].'?byuser='.$thisOwner['id'];?>">
                        <img src="<?php echo str_replace('{{siteUrl}}',$ninja_config['siteUrl'], $thisOwner['avatar']);?>" alt="<?php echo $thisOwner['username']; ?>" class="img-circle user-avt-sm">
                      </a>
                    <?php else: ?> 
                      <a data-toggle="tooltip" data-placement="right" title="<?php echo $lang['Anonymous'];?>" href="#">
                        <img src="<?php echo str_replace('{{siteUrl}}', $ninja_config['siteUrl'], $user_config['default_avt']);?>" alt="$thisOwner['username']" class="img-circle user-avt-sm">
                      </a>
                    <?php endif; ?>
                    </div>
                    <div class="col-lg-9 col-sm-10 col-xs-10">
                      <h3><?php echo $thisFu['title']; ?></h3>
                      <p>
                        <?php echo '<strong>'.$lang['Category'].'</strong>: <a href="'.$ninja_config['siteUrl'].$fufu_slug['index'].'?cat='.$thisFu['cat'].'">'.$ninja_fufu->do_cat($thisFu['cat']).'</a>'; ?> &middot;
                        <?php if($fufu_config['is_ago'] == '1'): ?>
                          <?php echo $lang['Posted']; ?> <span><?php echo $ninja_fufu->time_elapsed_string($thisFu['added']); ?></span>
                        <?php else: ?>
                          <?php echo $lang['Posted-on']; ?> <span><?php echo date("l, dS F Y", strtotime($thisFu['added']));?></span>
                        <?php endif; ?> &middot;
                        <i class="icon-comment-3"></i> 
                        <?php if(is_array($fufu_config['comment_type']) && in_array('1', $fufu_config['comment_type'])): ?>
                          <span><?php echo $thisFu['comment_count']; ?> <?php echo $lang['Comments']; ?></span> &middot;
                        <?php elseif(is_array($fufu_config['comment_type']) && in_array('0', $fufu_config['comment_type'])): ?>
                          <span><fb:comments-count href=<?php echo $ninja_config['siteUrl'].$thisFu['slug']; ?>></fb:comments-count> <?php echo $lang['Comments']; ?></span> &middot;
                        <?php endif; ?>
                        <i class="icon-eye-1"></i> <span><?php echo $thisFu['views'].' '.$lang['Views']; ?></span>
                      </p>
                      <p>
                        <div class="btn-group" data-id="<?php echo $thisFu['f_id'];?>" data-href="<?php echo $ninja_config['siteUrl'];?>/ninja-applications/fufu/controllers/cont.like.php">
                          <button type="button" class="btn-rate btn btn-sm btn-info" data-action="like"><i class="icon-thumbs-up"></i> <?php echo $lang['Like'];?></button>
                          <button type="button" class="btn-rate btn btn-sm btn-info" data-action="dislike" data-toggle="tooltip" data-placement="top" title="" data-original-title="<?php echo $lang['Dislike'];?>"><i class="icon-thumbs-down"></i></button>
                        </div>
                        <?php if(($ninja_user->isLoggedIn() AND $thisFu['poster_id'] == $_SESSION['thisUser']['id']) OR ($ninja->isAdmin())): ?>
                        <a type="button" class="btn-rate btn btn-sm btn-info" data-toggle="modal" data-target="#editFu"><i class="icon-wrench"></i> <?php echo $lang['Edit'];?></a>
                        <button class="btn btn-sm btn-danger delete-media-before" data-id="<?php echo $thisFu['f_id'];?>"><i class="icon-cancel-5"></i> <?php echo $lang['Delete'];?></button>
                        <button class="btn btn-sm btn-danger delete-media-confirm delete-media-after-<?php echo $thisFu['f_id'];?>" data-id="<?php echo $thisFu['f_id'];?>" data-slug="<?php echo $thisFu['slug'];?>" data-href="<?php echo $ninja_config['siteUrl'];?>/ninja-applications/fufu/controllers/edit-fu.php" data-redirect="<?php echo $ninja_config['siteUrl'].$fufu_slug['index'].'?byuser='.$_SESSION['thisUser']['id']; ?>" style="display:none"><i class="icon-question"></i> <?php echo $lang['Are-you-sure']; ?></button>
                        <?php endif; ?>
                        <button id="btn-rate-loading-<?php echo $thisFu['f_id'];?>" type="button" class="btn btn-sm btn-info" style="display:none"><i class="icon-spin6 animate-spin"></i> <?php echo $lang['Loading']; ?></button>
                      </p>
                    </div>
                    <div id="rate-div-<?php echo $thisFu['f_id'];?>" class="display-rate">
                      <?php echo $thisFu['rating'] > 0 ? '+'.$thisFu['rating'] : $thisFu['rating']; ?>
                    </div>
                  </div>
                </div>
                <div class="panel-body fu-listing">
                    <?php if($fufu_config['is_addthis'] == '1'){ ?>
                      <div class="addthis">
                        <!-- AddThis Button BEGIN -->
                        <div class="addthis_toolbox addthis_default_style">
                        <a class="addthis_button_facebook_like" fb:like:layout="button_count"></a>
                        <a class="addthis_button_google_plusone" g:plusone:size="medium"></a>
                        <a class="addthis_button_tweet"></a>
                        <a class="addthis_counter addthis_pill_style"></a>
                        </div>
                        <script type="text/javascript">var addthis_config = {"data_track_addressbar":true};</script>
                        <script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=<?php echo isset($fufu_config['addthis_id']) ? $fufu_config['addthis_id'] : 'ra-52348b146fa99d90';?>"></script>
                        <!-- AddThis Button END -->
                      </div>
                    <?php } //end ADDTHIS ?>
                    <?php if(isset($fufu_config['nsfw_cat']) && in_array($thisFu['cat'], $fufu_config['nsfw_cat']) && $fufu_config['nsfw_lock'] == '4' && (!isset($_COOKIE['age']) || $_COOKIE['age'] != '1')): ?>
                            <h2 style="text-align:center;margin-top:100p"><?php echo $lang['nsfw-head'];?></h2>
                            <p style="text-align:center;margin-bottom:100px"><?php echo $lang['fufu-confirm-age'];?></p>
                            <p style="text-align:center;margin-bottom:100px">
                              <button id="verify-age" type="button" class="btn btn-danger btn-large"><?php echo $lang['fufu-age-verify']; ?></button>
                            </p>
                    <?php elseif(isset($fufu_config['nsfw_cat']) && in_array($thisFu['cat'], $fufu_config['nsfw_cat']) && !in_array($fufu_config['nsfw_lock'], array('3','4'))): ?>
                        <?php if(($fufu_config['nsfw_lock'] == 1 || $fufu_config['nsfw_lock'] == 2) && !$ninja_user->isLoggedin()): ?>
                            <h2 style="text-align:center;margin-top:100p"><?php echo $lang['nsfw-head'];?></h2>
                            <p style="text-align:center;margin-bottom:100px">
                              <?php echo $lang['nsfw-login']; ?>
                            </p>
                        <?php elseif($_SESSION['thisUser']['point'] < $fufu_config['nsfw_point_need']): ?>
                            <h2 style="text-align:center;margin-top:100p"><?php echo $lang['nsfw-head'];?></h2>
                            <p style="text-align:center;margin-bottom:100px">
                              <?php echo sprintf($lang['nsfw-point-need'], $fufu_config['nsfw_point_need']); ?>
                            </p>
                        <?php else: ?>
                            <div>
                              <?php echo $ninja_fufu->do_fu($thisFu); ?>
                              <p>
                                <?php echo $thisFu['description'] != NULL ? '<hr>'.$ninja_fufu->do_fu_description($thisFu['description']) : ''; ?>
                                <?php echo $thisFu['source'] != NULL ? '<hr>'.$print_source : ''; ?>
                              </p>
                            </div>
                        <?php endif; ?>
                    <?php else: ?>
                      <div class="fu-lock">
                        <?php echo $ninja_fufu->do_fu($thisFu); ?>
                        <p>
                          <?php echo $thisFu['description'] != NULL ? '<hr>'.$ninja_fufu->do_fu_description($thisFu['description']) : ''; ?>
                          <?php echo $thisFu['source'] != NULL ? '<hr>'.$print_source : ''; ?>
                        </p>
                      </div>
                    <?php endif; ?>
                  <?php if($previous_fu != NULL): ?><a href="<?php echo $ninja_config['siteUrl'].$previous_fu; ?>" class="btn btn-sm btn-danger prev-fu"><i class="glyphicon glyphicon-chevron-left"></i></a><?php endif; ?>
                  <?php if($next_fu != NULL): ?><a href="<?php echo $ninja_config['siteUrl'].$next_fu; ?>" class="btn btn-sm btn-danger next-fu"><i class="glyphicon glyphicon-chevron-right"></i></a><?php endif;?>
                  <?php if($fufu_config['is_addthis'] == '0'): /* START SHARING METHOD */ ?>
                  <div class="cleafix"><br /></div>
                    <button onclick="fbShare('<?php echo $ninja_config['siteUrl'].$thisFu['slug'];?>', '<?php echo addslashes($thisFu['title']);?>', '<?php echo addslashes(str_replace("\n", '\r\n', str_replace("#", '%2523', $thisFu['description'])));?>', '<?php echo $ninja_config['siteUrl'].$thisFu['original_img'];?>', 520, 350)" type="button" class="btn btn-sm btn-info btn-fb"><i class="icon-facebook-squared-1"></i> Facebook</button>
                    <button onclick="twitterShare('<?php echo $ninja_config['siteUrl'].$thisFu['slug'];?>', '<?php echo addslashes($thisFu['title']);?>','520','350')" type="button" class="btn btn-sm btn-info"><i class="icon-twitter-1"></i> Twitter</button>
                    <button onclick="ggShare('<?php echo $ninja_config['siteUrl'].$thisFu['slug'];?>','520','350')" type="button" class="btn btn-sm btn-info btn-gplus"><i class="icon-gplus"></i> Plus 1</button>
                    <button onclick="pinShare('<?php echo $ninja_config['siteUrl'].$thisFu['slug'];?>', '<?php echo addslashes($thisFu['title']);?>', '<?php echo $ninja_config['siteUrl'].$thisFu['original_img'];?>','520','350')" type="button" class="btn btn-sm btn-info btn-pin"><i class="icon-pinterest-3"></i> Pin</button>
                  <?php endif; /* END SHARING METHOD */ ?> 
                  <!-- RELATED FU -->
                  <?php include 'layouts/related.php'; ?>
                  <!-- END RELATED FU -->  

                  <!-- COMMENT -->
                  <?php include 'layouts/display_comment.php'; ?>

                </div>
              </div>
              <?php include ROOT_DIR.'/ninja-applications/fufu/themes/default/layouts/ads2.html'; ?>
          </div>
          <div class="col-lg-4">
            <?php include ROOT_DIR.'/ninja-applications/fufu/themes/default/layouts/sidebar.php'; ?>
          </div>
        </div>
      </div>

    </div>


   
    <?php include ROOT_DIR.'/ninja-applications/fufu/themes/default/layouts/footer.php'; ?>

    <?php include ROOT_DIR.'/ninja-applications/fufu/themes/default/layouts/beforebody.html'; ?>

    <?php 
      if(isset($fufu_config['sociallock_cat']) && in_array($thisFu['cat'], $fufu_config['sociallock_cat'])): 
      $sociallock_buttons = implode("\",\"", $fufu_config['sociallock_button']);
    ?>
      <script>
        jQuery(document).ready(function ($) {
          $(".fu-lock").sociallocker({
              demo: false,
              text: "<?php echo $fufu_config['sociallock_text'];?>",
              theme: "<?php echo $fufu_config['sociallock_theme'];?>",
              buttons: {
                  order: ["<?php echo $sociallock_buttons;?>"]
              },
              facebook: {
                  appId: "<?php echo $fufu_config['fb_id'];?>",
                  like: { url: "<?php echo $ninja->currentUrl();?>" }
              },
              twitter: {
                  tweet: { url: "<?php echo $ninja->currentUrl();?>" }
              },
              google: {
                  plus: { url: "<?php echo $ninja->currentUrl();?>" }
              }
          });

        });
      </script>
      
    <?php endif; ?>

  <script src="<?php echo $ninja_config['siteUrl'];?>/ninja-applications/fufu/themes/default/assets/js/custom-comment.js"></script>
  </body>
</html>