<?php

    $user_config = json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/user/lib/config.user.inc'), true);

    // Language
    $lang = array_merge($lang, json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/user/locales/'.$user_config['locale']), true));

    class ninja_user extends ninja{
        var $lang = '';
        var $user_config = array();

        public function setLang(array $lang) {
            $this->lang = $lang;
        }
        public function setConfig(array $array) {
            $this->user_config = $array;
        }
        public function setAvt($uId){
            if(file_exists(ROOT_DIR.'/uploads/avt/'.$uId.'.jpg')){
                $_SESSION['thisUser']['avt'] = '{{siteUrl}}/uploads/avt/'.$uId.'.jpg';
                $this->db->dbUpdate($this->ninja_config['TABLES_PREFIX']."users",array("avatar"=>'{{siteUrl}}/uploads/avt/'.$uId.'.jpg'),array("id"=>$uId)); 
            }
            return true;
        }
        function isLoggedIn(){
            if(isset($_SESSION['thisUser']) && !empty($_SESSION['thisUser'])){
                return 1;
            }
            return 0;
        }
        function login_hash($uid,$password){
            return md5($uid.$password);
        }
        function pw_with_salt($salt,$password){
            return sha1($salt.$password);
        }
        function is_email_exist($email){
            $this->db->limit_val = "1";
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."users",array("id"),array("email"=>$email));
            if(count($result) == '1'){
                return true;
            }
            return false;    
        }
        function is_username_valid($username){
            if(preg_match('/[^a-zA-Z0-9_]/', $username) == 0){
                return false;
            }
            return true;
        }
        function is_username_exist($username){
            $this->db->limit_val = "1";
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."users",array("id"),array("username"=>$username));
            if(count($result) == '1'){
                return true;
            }
            return false;    
        }
        function is_ip_exist($ip){
            $this->db->limit_val = "1";
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."users",array("id"),array("register_ip"=>$ip));
            if(count($result) == '1'){
                return true;
            }
            return false;    
        }
        function user_login_check($usernameoremail,$password){
            if(filter_var(trim($usernameoremail), FILTER_VALIDATE_EMAIL)){
                $condition = array('email'=>$usernameoremail);
            }else{
                $condition = array('username'=>$usernameoremail);
            }
            $this->db->limit_val = "1";
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."users","",$condition);
            if(count($result) == '1'){
                if($this->pw_with_salt($result[0]['salt'],$password) == $result[0]['password']){
                    return $result[0];
                }
                return false;
            }
            return false;    
        }

        function log_login($id,$ip,$lang,$browser,$platform,$oauth,$time,$sessionid){   
            $nowInStr = strtotime($time);
            $someHoursBeforeNow = $nowInStr-(60*60*1);
            $someHoursBeforeNow = date("Y-m-d H:i:s", $someHoursBeforeNow);
            $query  = "select id from ".$this->ninja_config['TABLES_PREFIX']."user_login_logs WHERE uid =? AND sessionid =? AND time BETWEEN ? AND ?";            
            $parameter_values=array($id,$sessionid,$someHoursBeforeNow,$time);
            $result = $this->db->dbExecuteQuery($query,$parameter_values);
            if(count($result) < 1){ 
                $this->db->dbInsert($this->ninja_config['TABLES_PREFIX']."user_login_logs",array("uid"=>$id,"ip"=>$ip,"language"=>$lang,"browser"=>$browser,"platform"=>$platform,"oauth_provider"=>$oauth,"time"=>$time,"sessionid"=>$sessionid));     
            }
        }
        function nameFromEmail($email){
            $parts = explode("@",$email);
            return $parts[0];
        }

        function locale_list(){
            if ($handle = opendir(ROOT_DIR.'/ninja-applications/user/locales/')) {
                while (false !== ($entry = readdir($handle))) {
                    if ($entry != "." && $entry != "..") {
                        echo "<option value='$entry' ".($entry == $this->user_config['locale'] ? 'selected' : '').">".ucfirst(str_replace('.php', '', $entry))."</option>";
                    }
                }
                closedir($handle);
           }
        }

        function email_confirmation($email, $code){
            $this->db->limit_val = "1";
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."users",array("id"),array("code"=>$code,'email'=>$email));
            if(count($result) == '1'){
                $this->db->dbUpdate($this->ninja_config['TABLES_PREFIX']."users",array("role"=>"1","code"=>''),array("email"=>$email)); 
                return true;
            }
                return false;
        }
        function resetpw($email, $code){
            $this->db->limit_val = "1";
            $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."users",array("salt"),array("code"=>$code,'email'=>$email));
            if(count($result) == '1'){
                $newpw = $this->pw_with_salt($result[0]['salt'],'123456');
                $this->db->dbUpdate($this->ninja_config['TABLES_PREFIX']."users",array("password"=>$newpw,"code"=>''),array("email"=>$email)); 
                return true;
            }
                return false;
        }
        function getBrowser(){ 
            $u_agent = $_SERVER['HTTP_USER_AGENT']; 
            $bname = 'Unknown';
            $platform = 'Unknown';
            $version= "";

            //First get the platform?
            if (preg_match('/linux/i', $u_agent)) {
                $platform = 'linux';
            }
            elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
                $platform = 'mac';
            }
            elseif (preg_match('/windows|win32/i', $u_agent)) {
                $platform = 'windows';
            }
            
            // Next get the name of the useragent yes seperately and for good reason
            if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent)) 
            { 
                $bname = 'Internet Explorer'; 
                $ub = "MSIE"; 
            } 
            elseif(preg_match('/Firefox/i',$u_agent)) 
            { 
                $bname = 'Mozilla Firefox'; 
                $ub = "Firefox"; 
            } 
            elseif(preg_match('/Chrome/i',$u_agent)) 
            { 
                $bname = 'Google Chrome'; 
                $ub = "Chrome"; 
            } 
            elseif(preg_match('/Safari/i',$u_agent)) 
            { 
                $bname = 'Apple Safari'; 
                $ub = "Safari"; 
            } 
            elseif(preg_match('/Opera/i',$u_agent)) 
            { 
                $bname = 'Opera'; 
                $ub = "Opera"; 
            } 
            elseif(preg_match('/Netscape/i',$u_agent)) 
            { 
                $bname = 'Netscape'; 
                $ub = "Netscape"; 
            } 
            
            // finally get the correct version number
            $known = array('Version', $ub, 'other');
            $pattern = '#(?<browser>' . join('|', $known) .
            ')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
            if (!preg_match_all($pattern, $u_agent, $matches)) {
                // we have no matching number just continue
            }
            
            // see how many we have
            $i = count($matches['browser']);
            if ($i != 1) {
                //we will have two since we are not using 'other' argument yet
                //see if version is before or after the name
                if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
                    $version= $matches['version'][0];
                }
                else {
                    $version= $matches['version'][1];
                }
            }
            else {
                $version= $matches['version'][0];
            }
            
            // check if we have a number
            if ($version==null || $version=="") {$version="?";}
            
            return array(
                'userAgent' => $u_agent,
                'name'      => $bname,
                'version'   => $version,
                'platform'  => $platform,
                'pattern'    => $pattern
            );
        } 

    }

    // outside function

    $ninja_user = new ninja_user($ninja_config);
    $ninja_user->setLang($lang);
    $ninja_user->setConfig($user_config);

    // CHECK IF THIS USER CHANGED THIS AVATAR
    if(isset($_SESSION['uId']) && $_SESSION['uId'] != NULL && !isset($_SESSION['thisUser'])){
        $ninja->db->limit_val = "1";
        $result = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users","",array("id"=>$_SESSION['uId'])); 
        $_SESSION['thisUser'] = $result[0];
        $ninja_user->setAvt($_SESSION['thisUser']['id']);
    }

    // CHECK IF THIS USER "IS_REMEMBERED"
    if(isset($_COOKIE['uid']) && isset($_COOKIE['hash']) && is_numeric($_COOKIE['uid']) && !isset($_SESSION['thisUser'])){
        $ninja->db->limit_val = "1";
        $result = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users","",array("id"=>$_COOKIE['uid'])); 
        if($ninja_user->login_hash($_COOKIE['uid'],$result[0]['password']) == $_COOKIE['hash']){
            $_SESSION['uId'] = $_COOKIE['uid'];
            $_SESSION['thisUser'] = $result[0];
        }else{
            unset($_COOKIE['uid']);
        }
    }
