<?php

	include '../../../ninja-controllers/cont.main.php';
	
	sleep(1);
	// LOAD EMAIL TEMPLATE
	$mail_template = json_decode(file_get_contents(ROOT_DIR.'/ninja-applications/user/lib/email.temp.user.inc'), true); 
	// END LOAD EMAIL TEMPLATE

	// CONFIG MAILER				
	$mail = new PHPMailer();
	//$mail->SMTPDebug = 2;
	//$mail->Debugoutput = 'html';
	//is SMTP in use?
	if($mailer_config['smtp'] == 1){
		$mail->isSMTP();
		$mail->Host = $mailer_config['smtp_host'];
		$mail->Port = $mailer_config['smtp_port'];
		$mail->SMTPSecure = $mailer_config['smtp_secure'];
		$mail->SMTPAuth = $mailer_config['smtp_auth'];
		$mail->Username = $mailer_config['smtp_username'];
		$mail->Password = $mailer_config['smtp_password'];
	}

	$mail->setFrom($mailer_config['email_from'], 'no-reply' );
	$mail->addReplyTo($mailer_config['email_from'], $ninja_config['siteTitle'] );
	// END CONFIG MAILER

	$r = array(); // r mean return. This POST controllers will return an json with 'status' (ok for 1 and ko for 0) and 'message' for message. 

	if(!isset($_POST['token']) || $_POST['token'] != $_SESSION['token']){
			$r['status'] = 'ko';
			$r['message'] = 'Failed to pass security validations';
			echo json_encode($r);
			exit;
	}

	/**
	 * @var  LOGIN
	 */

	if(isset($_POST['action']) && $_POST['action'] == 'login'){
		if(trim($_POST['password']) == ""){ die(); }
		$thisUser = $ninja_user->user_login_check(trim($_POST['usernameoremail']),$_POST['password']);
		if($thisUser != false){
			if($thisUser['role'] == '0'){
				if($user_config['email-active'] == '1'){
					$r['status'] =  'ko';
					$r['message'] = $lang['please-active-email'];
				}else{
					$r['status'] =  'ko';
					$r['message'] = $lang['please-wait-confirm'];
				}
				echo json_encode($r);
				exit;
			}
			if(isset($_POST['remember']) && $_POST['remember'] == 'yes'){
				$_SESSION['uId'] = $thisUser['id'];
				$_SESSION['thisUser'] = $thisUser;
				setcookie("uid",  $thisUser['id'],  time() + (10 * 365 * 24 * 60 * 60), '/', NULL, 0 ); 
				setcookie("hash", $ninja_user->login_hash($thisUser['id'],$thisUser['password']),  time() + (10 * 365 * 24 * 60 * 60), '/', NULL, 0 ); 
			}else{
				$_SESSION['uId'] = $thisUser['id'];
				$_SESSION['thisUser'] = $thisUser;
			}	
			$ninja_user->setAvt($_SESSION['thisUser']['id']);
			// LOG THE LOGIN AND RETURN STATUS
			$thisUserGetBrowser = $ninja_user->getBrowser();
			$ninja_user->log_login($thisUser['id'],$_SERVER['REMOTE_ADDR'],substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2),$thisUserGetBrowser['name'].' '.$thisUserGetBrowser['version'],$thisUserGetBrowser['platform'],NULL,$now,session_id());	
			$r['status'] = 'ok';
			$r['message'] = 'Login successful';
		}else{
			$r['status'] = 'ko';
			$r['message'] = 'Login failed, incorrect email or password.';
		}
			echo json_encode($r);
			exit;
	}
	
	/**
	 * @var  REGISTER
	 */

	if(isset($_POST['action']) && $_POST['action'] == 'register'){
		if((isset($_COOKIE['isRegistered']) && $_COOKIE['isRegistered'] == 1) || $ninja_user->is_ip_exist($_SERVER['REMOTE_ADDR'])){
			$r['status'] = 'ko';
			$r['message'] = $lang['register-limit'];
		}else if (!filter_var(trim($_POST['email']), FILTER_VALIDATE_EMAIL)) {
			$r['status'] = 'ko';
			$r['message'] = $lang['invalid-email'];
		}else if(!isset($_POST['password'])){
			$r['status'] = 'ko';
			$r['message'] = $lang['fill-full-the-form'];
		}else if($_POST['password'] != $_POST['password2']){
			$r['status'] = 'ko';
			$r['message'] = $lang['pw-does-not-match'];
		}else if($ninja_user->is_username_valid(trim($_POST['username']))){
			$r['status'] = 'ko';
			$r['message'] = $lang['username-is-not-valid'];
		}else if($ninja_user->is_email_exist(trim($_POST['email']))){
			$r['status'] = 'ko';
			$r['message'] = $lang['email-is-exist'];
		}else if($ninja_user->is_username_exist(trim($_POST['username']))){
			$r['status'] = 'ko';
			$r['message'] = $lang['username-is-exist'];
		}else{	
			$_POST['role'] = ($user_config['email-active'] == '1' ? '0' : '1');
			$activate_code = $ninja->random_md5();
			$salt = $ninja->random_md5();
			$_POST['name'] = $ninja_user->nameFromEmail($_POST['email']);
			$userInfo = array('username'=>trim($_POST['username']),
							  'email'=>trim($_POST['email']),
							  'displayname'=>$_POST['name'],
							  'avatar'=>$user_config['default_avt'],
							  'password'=>$ninja_user->pw_with_salt($salt,$_POST['password']),
							  'role'=>$_POST['role'],
							  'salt'=>$salt,
							  'register_ip'=>$_SERVER['REMOTE_ADDR'],
							  'register_date'=>$now,
							  'code'=>$activate_code,
							  );
			$ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."users", $userInfo); 
			$userInfo['id'] = $ninja->db->last_insert_id;

			// ACTIVATION BY CONFIRMATION LINK
			if($user_config['email-active'] == '1'){
				$mail->addAddress($_POST['email']);
				$mail->Subject = $lang['Activation-subject'].$ninja_config['siteTitle'];
				$mail->IsHTML(true);
				$mail_info = array('{{display_name}}'=>$_POST['name'],
								   '{{site_name}}'=>$ninja_config['siteTitle'],
								   '{{confirmation_link}}'=>$ninja_config['siteUrl'].'/usercp?action=activation&code='.$activate_code.'&email='.$_POST['email']);
				$mail_body = strtr($mail_template['link_confirm_email'] ,$mail_info);
				$mail->Body = $mail_body;
				if (!$mail->send()) {
					$r['status'] = 'ko';
					$r['message'] = "Mailer Error: " . $mail->ErrorInfo;
				} else {
					$r['status'] = 'ok';
					$r['message'] = $lang['check-your-email'];
				}
			// ACTIVATION BY ADMIN	
			}else if($user_config['email-active'] == '2'){
				$mail->addAddress($_POST['email']);
				$mail->Subject = $lang['Activation-by-admin-subject'].$ninja_config['siteTitle'];
				$mail->IsHTML(true);
				$mail_info = array('{{display_name}}'=>$_POST['name'],
								   '{{site_name}}'=>$ninja_config['siteTitle']
								   );
				$mail_body = strtr($mail_template['manual_confirm_email'] ,$mail_info);
				$mail->Body = $mail_body;
				if (!$mail->send()) {
					$r['status'] = 'ko';
					$r['message'] = "Mailer Error: " . $mail->ErrorInfo;
				} else {
					$r['status'] = 'ok';
					$r['message'] = $lang['please-wait-for-approval'];
				}
			// NO ACTIVATION NEEDED
			}else{
				$mail->addAddress($_POST['email']);
				$mail->Subject = $lang['welcome-email-title'] .$ninja_config['siteTitle'];
				$mail->IsHTML(true);
				$mail_info = array('{{display_name}}'=>$_POST['name'],
								   '{{site_name}}'=>$ninja_config['siteTitle']
								   );
				$mail_body = strtr($mail_template['welcome_email'] ,$mail_info);
				$mail->Body = $mail_body;
				if (!$mail->send()) {
					$r['status'] = 'ko';
					$r['message'] = "Mailer Error: " . $mail->ErrorInfo;
				} else {
					$r['status'] = 'ok';
					$r['message'] = $lang['register-successful'];	
				}
			}
			setcookie("isRegistered",  1,  time() + (10 * 365 * 24 * 60 * 60), '/', NULL, 0 );
		}

		echo json_encode($r);
		exit;

	}

	
	/**
	 * @var  LOGOUT
	 */

	if(isset($_POST) && $_POST['action'] == 'logout' && $_POST['token'] == $_SESSION['token']){
		unset($_SESSION['thisUser']);
		unset($_SESSION['uId']);
		setcookie("uid",  NULL,  time() + (10 * 365 * 24 * 60 * 60), '/', NULL, 0 ); 
		$r['status'] = 'ok';
		$r['message'] = '';
		echo json_encode($r);
		exit;

	}
	
	/** 
	* @var RESET PW STEP 1
	*/

	if(isset($_POST) && $_POST['action'] == 'forgot_password' && $_GET['token'] == $_SESSION['token']){
		/* VALID EMAIL OR NOT? */
		if (!filter_var(trim($_POST['email']), FILTER_VALIDATE_EMAIL)) {
			$r['status'] = 'ko';
			$r['message'] = $lang['invalid-email'];
			echo json_encode($r);
			exit;
		}
		/* GET THIS USER INFO VIA EMAIL */
		$ninja->db->limit_val='';
		$thisUser = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users", "", array('email'=>$_POST['email'])); 
		if(count($thisUser) == 0){
			$r['status'] = 'ko';
			$r['message'] = $lang['Email-not-exist'];
			echo json_encode($r);
			exit;
		}elseif($thisUser[0]['role'] == 0){
			$r['status'] = 'ko';
			$r['message'] = $lang['please-active-email'];
			echo json_encode($r);
			exit;
		}elseif($thisUser[0]['code'] != ''){
			$r['status'] = 'ko';
			$r['message'] = $lang['reset-pw-already-sent'];
			echo json_encode($r);
			exit;
		}
		/* GENERATE THE CODE AND DO SOMETHING */
		$code = md5(uniqid(rand(), true));
		$ninja->db->dbUpdate($ninja_config['TABLES_PREFIX']."users", array('code'=>$code), array('email'=>$_POST['email'])); 
		
		/* GENERATE EMAIL INFO AND SEND */
		$mail->addAddress($_POST['email']);
		$mail->Subject = $lang['Pw-change-subject'].$ninja_config['siteTitle'];
		$mail->IsHTML(true);
		$mail_info = array('{{display_name}}'=>$thisUser[0]['displayname'],
						   '{{site_name}}'=>$ninja_config['siteTitle'],
						   '{{confirmation_link}}'=>$ninja_config['siteUrl'].'/usercp?action=changepassword&code='.$code.'&email='.$_POST['email']);
		$mail_body = strtr($mail_template['new_password_email'] ,$mail_info);
		$mail->Body = $mail_body;
		if (!$mail->send()) {
			$r['status'] = 'ko';
			$r['message'] = "Mailer Error: " . $mail->ErrorInfo;
		} else {
			$r['status'] = 'ok';
			$r['message'] = $lang['reset-pw-email-done'];
		}
		echo json_encode($r);
		exit;
	}	

	/** 
	* @var RESET PW STEP 2
	*/
	/*
	if($_GET['action'] == 'reset_pw' && isset($_GET['code']) && isset($_GET['email'])){
		if($huy->isExist(APP_TABLES_PREFIX . 'user_code','code',array('email'=>$_GET['email']))){
			$rand = substr(str_shuffle('abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789') , 0 , 10 );
			$db->UPDATE(APP_TABLES_PREFIX . 'user',array('email'=>$_GET['email']),array('password'=>sha1($rand)));
			$db->Delete(APP_TABLES_PREFIX . 'user_code',array('email'=>$_GET['email']));
			echo $l['Your_new_pw'].': <strong>'. $rand.'</strong><br />';
			echo '<a href="index.html">'.$l['Back_UCP'].'<a/>';
		}else{
			echo $l['Reset_fail'];
			header( "Refresh:2; url=../ucp/login.html", true, 303);
		}
	}

	*/