<?php
  
  include '../../../ninja-controllers/cont.main.php';
  require '../lib/openid.php';
  if($user_config['gg-login'] != 1){
    die;
  }
    try {
        $openid = new LightOpenID($ninja_config['siteUrl']);
        if(!$openid->mode) {
            if(isset($_GET['login'])) {
                $openid->identity = 'https://www.google.com/accounts/o8/id';
                $openid->required = array('namePerson/first','namePerson/last','contact/email' );
                header('Location: ' . $openid->authUrl());
            }
        } elseif($openid->mode == 'cancel') {
            echo 'You has canceled authentication!';
        } else {
            if($openid->validate()){
                $attributes = $openid->getAttributes();
                if(!isset($attributes['contact/email'])){
                    echo $lang['cannot-get-email'];
                    exit;
                }else{
                    $email = $attributes['contact/email'];
                    $username = isset($attributes['namePerson/friendly']) ? $attributes['namePerson/friendly'] : '';
                    if($username == ''){ $username = $ninja_user->nameFromEmail($email); }
                    /* CHECK IF USER ALREADY LOGIN ONCE */
                    $ninja->db->limit_val='1';
                    $thisUser = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users","",array('email'=>$email)); 
                    if(count($thisUser) > 0){
                        $_SESSION['uId'] = $thisUser[0]['id'];
                        $_SESSION['thisUser'] = $thisUser[0];
                        header("Location: ".$ninja_config['siteUrl']);
                        exit;
                    }else{
                        $thisUserUname = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users","",array('username'=>$username));
                        if(count($thisUserUname) > 0){
                            $username = uniqid();
                        }
                        $user_info = array('username'=>$username,
                                'email'=>$email,
                                'avatar'=>$user_config['default_avt'],
                                'displayname'=>$username,
                                'role'=>'1',
                                'register_date'=>$now,
                                'register_ip'=>$_SERVER['REMOTE_ADDR'],
                                );
                        $ninja->db->dbInsert($ninja_config['TABLES_PREFIX']."users",$user_info);
                        $user_id = $ninja->db->last_insert_id; 
                        $thisUser = $ninja->db->dbSelect($ninja_config['TABLES_PREFIX']."users","",array('id'=>$user_id));
                        $_SESSION['uId'] = $thisUser[0]['id'];
                        $_SESSION['thisUser'] = $thisUser[0];
                        header("Location: ".$ninja_config['siteUrl']);
                        exit;
                    }
                }
            }
            echo 'User ' . ($openid->validate() ? $openid->identity . ' has ' : 'has not ') . 'logged in.';
        }
    } catch(ErrorException $e) {
        echo $e->getMessage();
    }
