<!DOCTYPE html>
<html lang="en">
<head>

    <!-- Basic Page Needs
  ================================================== -->
    <meta charset="utf-8">
    <title>Flat Login</title>
    <meta name="description" content="">
    <meta name="author" content="">

    <!-- Mobile Specific Metas
  ================================================== -->
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

    <!-- CSS
  ================================================== -->

    <!--[if lt IE 9]>
		<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
    <link href="//netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css" rel="stylesheet">
    <link href="<?php echo $ninja_config['siteUrl'].'/ninja-applications/user/themes/default/assets/css.css'; ?>" rel="stylesheet" type="text/css" />
    <script class="cssdeck" src="//cdnjs.cloudflare.com/ajax/libs/jquery/1.8.0/jquery.min.js"></script>
</head>
<body>

    <div class="container">
        <div class="flat-form">
            <ul class="tabs">
                <li>
                    <a href="#login" class="active"><?php echo ucfirst($lang['login']);?></a>
                </li>
                <li>
                    <a href="#register"><?php echo ucfirst($lang['register']);?></a>
                </li>
                <li>
                    <a href="#reset"><?php echo ucfirst($lang['reset-password']);?></a>
                </li>
            </ul>
            <div id="login" class="form-action show">
                <h1><?php echo ucfirst($lang['login']);?></h1>
                <p>
                    <?php if($user_config['fb-login'] == 1): ?>
                    <?php echo $lang['login-with'];?> <a href="usercp?action=facebooklogin" class="login"><i class="fa fa-facebook-square"></i> Facebook</a>
                    <?php endif ?>
                </p>
                <form id="login-form" method="POST" action="<?php echo $ninja_config['siteUrl'].'/ninja-applications/user/controllers/cont.userForm.php';?>">
                    <input type="hidden" name="token" value="<?php echo $_SESSION['token'];?>" />
                    <input type="hidden" name="action" value="login" />
                    <ul>
                        <li>
                            <input type="email" name="email" required placeholder="<?php echo ucfirst($lang['email-or-username']); ?>" />
                        </li>
                        <li>
                            <input type="password" name="password" required placeholder="<?php echo ucfirst($lang['password']); ?>" />
                        </li>
                        <li style="margin-bottom: 10px;"><input type="checkbox" name="remember" value="yes"><?php echo $lang['Remember'];?></li>
                        <li>
                            <input type="submit" value="<?php echo ucfirst($lang['login']); ?>" class="button" />
                        </li>
                    </ul>
                </form>
            </div>
            <!--/#login.form-action-->
            <div id="register" class="form-action hide">
                <h1><?php echo ucfirst($lang['register']); ?></h1>
                <form id="register-form" method="POST" action="<?php echo $ninja_config['siteUrl'].'/ninja-applications/user/controllers/cont.userForm.php';?>">
                    <input type="hidden" name="token" value="<?php echo $_SESSION['token'];?>" />
                    <input type="hidden" name="action" value="register" />
                    <ul>
                        <li>
                            <input type="text" name="username" required placeholder="<?php echo ucfirst($lang['username']); ?>" />
                        </li>
                        <li>
                            <input type="email" name='email' required placeholder="<?php echo ucfirst($lang['email']); ?>" />
                        </li>
                        <li>
                            <input type="password" name='password' required placeholder="<?php echo ucfirst($lang['password']); ?>" />
                        </li>
                        <li>
                            <input type="password" name='password2' required placeholder="<?php echo ucfirst($lang['cf-password']); ?>" />
                        </li>
                        <li>
                            <input type="submit" value="<?php echo ucfirst($lang['sign-up']); ?>" class="button" />
                        </li>
                    </ul>
                </form>
            </div>
            <!--/#register.form-action-->
            <div id="reset" class="form-action hide">
                <h1><?php echo ucfirst($lang['reset-password']); ?></h1>
                <p>
                    <?php echo $lang['reset-password-ex'] ; ?>
                </p>
                <form id="reset-form" method="POST" action="<?php echo $ninja_config['siteUrl'].'/ninja-applications/user/controllers/cont.userForm.php';?>">
                    <input type="hidden" name="token" value="<?php echo $_SESSION['token'];?>" />
                    <input type="hidden" name="action" value="reset" />
                    <ul>
                        <li>
                            <input type="email" name="email" placeholder="<?php echo ucfirst($lang['email']); ?>" />
                        </li>
                        <li>
                            <input type="submit" value="<?php echo $lang['Send']; ?>" class="button" />
                        </li>
                    </ul>
                </form>
            </div>
            <!--/#register.form-action-->
            <?php $ninja_user->form('register-form'); ?>
            <?php $ninja_user->form('login-form'); ?>
            <?php $ninja_user->form('reset-form'); ?>
            <?php if(isset($_GET['action']) && $_GET['action'] = 'activation' && isset($_GET['email']) && isset($_GET['code'])): ?>
                <?php if($ninja_user->email_confirmation($_GET['email'], $_GET['code'])): ?>
                    <script>$(document).ready(function () {var n1 = noty({layout: 'topRight', text: '<?php echo $lang['confirmation-success'];?>', type: 'success'});});</script>
                <?php else: ?>
                    <script>$(document).ready(function () {var n1 = noty({layout: 'topRight', text: '<?php echo $lang['confirmation-error'];?>', type: 'error'});});</script>
                <?php endif ?>
            <?php endif; ?>
        </div>
    </div>
    <!-- JS:notify -->
    <script type="text/javascript" src="<?php echo $ninja_config['siteUrl'];?>/ninja-admin/assets/js/noty/jquery.noty.js"></script>
    <script type="text/javascript" src="<?php echo $ninja_config['siteUrl'];?>/ninja-admin/assets/js/noty/layouts/topRight.js"></script>
    <script type="text/javascript" src="<?php echo $ninja_config['siteUrl'];?>/ninja-admin/assets/js/noty/themes/default.js"></script>
    <!-- JS:jQueryForm-->
    <script src="<?php echo $ninja_config['siteUrl'];?>/ninja-admin/assets/js/library/jquery.form.js"></script>
    <script src="<?php echo $ninja_config['siteUrl'].'/ninja-applications/user/themes/default/assets/js.js'; ?>"></script>

</body>
</html>


