<?php

	class ninja{

	    protected $ninja_config;
	    public $db;

	    public function __construct($ninja_config) {
	        $this->ninja_config =& $ninja_config;
	        $this->db = new SimplifiedDB(); 
			$this->db->charset="utf8";
			$this->db->dbConnect($ninja_config['DB_HOST'],$ninja_config['DB_USER'],$ninja_config['DB_PASSWORD'],$ninja_config['DB_NAME']);
	    }

		function isAdmin(){
			if(isset($_SESSION['isAdmin']) && $_SESSION['isAdmin'] == '1'){
				return true;
			}
			return false;
		}

		// Check if $application is enabled
		function isApplication($application){
			if(in_array($application, $this->ninja_config['applications'])){ return true; }
			return false;
		}

		function adminOnly(){
			if(!$this->isAdmin()){
				header('Location: '.$this->ninja_config['siteUrl'].'/ninja-admin/login.php');
				exit;
			}
		}

		function request($slug){
			$result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."slug",array("s_id","c_id","application","page","slug"),array("slug"=>$slug));
			$this->db->like_cols='';
			if(count($result) == '1'){
				return $result[0];
			}elseif(count($result) > '1'){
				foreach($result as &$request){
					if (strpos($slug, $request['slug']) !== false ) {
						return $request;
					}
				}
				return NULL;
			}
			return NULL;    
		}
		function random_md5(){
			return md5(uniqid(rand(), true));
		}
		// Add slashes to whole array element
		function arrayAddSlashes($input){
			if ( is_array( $input ) ){
				return array_map( __FUNCTION__, $input );
			}else{
				return addslashes( $input );
			}
		}  
		// Convert cyrillic to latin
		function ru2lat($str){
		    $tr = array(
		    "А"=>"a", "Б"=>"b", "В"=>"v", "Г"=>"g", "Д"=>"d",
		    "Е"=>"e", "Ё"=>"yo", "Ж"=>"zh", "З"=>"z", "И"=>"i", 
		    "Й"=>"j", "К"=>"k", "Л"=>"l", "М"=>"m", "Н"=>"n", 
		    "О"=>"o", "П"=>"p", "Р"=>"r", "С"=>"s", "Т"=>"t", 
		    "У"=>"u", "Ф"=>"f", "Х"=>"kh", "Ц"=>"ts", "Ч"=>"ch", 
		    "Ш"=>"sh", "Щ"=>"sch", "Ъ"=>"", "Ы"=>"y", "Ь"=>"", 
		    "Э"=>"e", "Ю"=>"yu", "Я"=>"ya", "а"=>"a", "б"=>"b", 
		    "в"=>"v", "г"=>"g", "д"=>"d", "е"=>"e", "ё"=>"yo", 
		    "ж"=>"zh", "з"=>"z", "и"=>"i", "й"=>"j", "к"=>"k", 
		    "л"=>"l", "м"=>"m", "н"=>"n", "о"=>"o", "п"=>"p", 
		    "р"=>"r", "с"=>"s", "т"=>"t", "у"=>"u", "ф"=>"f", 
		    "х"=>"kh", "ц"=>"ts", "ч"=>"ch", "ш"=>"sh", "щ"=>"sch", 
		    "ъ"=>"", "ы"=>"y", "ь"=>"", "э"=>"e", "ю"=>"yu", 
		    "я"=>"ya", " "=>"-", "."=>"", ","=>"", "/"=>"-",  
		    ":"=>"", ";"=>"","—"=>"", "–"=>"-"
		    );
		return strtr($str,$tr);
		}

		// Convert string to slug
        function slug($str) {
            $str = preg_replace("/(å|ä|à|á|ạ|ả|ã|â|ầ|ấ|ậ|ẩ|ẫ|ă|ằ|ắ|ặ|ẳ|ẵ|ą)/", 'a', $str);
            $str = preg_replace("/(è|é|ẹ|ẻ|ẽ|ê|ề|ế|ệ|ể|ễ|ę)/", 'e', $str);
            $str = preg_replace("/(ì|í|ị|ỉ|ĩ|ı)/", 'i', $str);
            $str = preg_replace("/(ö|ò|ó|ọ|ỏ|õ|ô|ồ|ố|ộ|ổ|ỗ|ơ|ờ|ớ|ợ|ở|ỡ)/", 'o', $str);
            $str = preg_replace("/(ü|ù|ú|ụ|ủ|ũ|ư|ừ|ứ|ự|ử|ữ)/", 'u', $str);
            $str = preg_replace("/(ỳ|ý|ỵ|ỷ|ỹ)/", 'y', $str);
            $str = preg_replace("/(đ)/", 'd', $str);
            $str = preg_replace("/(č|ç|ć)/", 'c', $str);
            $str = preg_replace("/(š,ş,ś)/", 's', $str);
            $str = preg_replace("/(ğ)/", 'g', $str);
            $str = preg_replace("/(Ğ)/", 'g', $str);
            $str = preg_replace("/(ž|ż|ź)/", 'z', $str);
            $str = preg_replace("/(Ä|Å|À|Á|Ạ|Ả|Ã|Â|Ầ|Ấ|Ậ|Ẩ|Ẫ|Ă|Ằ|Ắ|Ặ|Ẳ|Ẵ|Ą)/", 'A', $str);
            $str = preg_replace("/(È|É|Ẹ|Ẻ|Ẽ|Ê|Ề|Ế|Ệ|Ể|Ễ|Ę)/", 'E', $str);
            $str = preg_replace("/(Ì|Í|Ị|Ỉ|Ĩ|İ)/", 'I', $str);
            $str = preg_replace("/(Ö|Ò|Ó|Ọ|Ỏ|Õ|Ô|Ồ|Ố|Ộ|Ổ|Ỗ|Ơ|Ờ|Ớ|Ợ|Ở|Ỡ)/", 'O', $str);
            $str = preg_replace("/(Ù|Ú|Ụ|Ủ|Ũ|Ư|Ừ|Ứ|Ự|Ử|Ữ)/", 'U', $str);
            $str = preg_replace("/(Ỳ|Ý|Ỵ|Ỷ|Ỹ)/", 'Y', $str);
            $str = preg_replace("/(Č|Ç|Ć)/", 'C', $str);
            $str = preg_replace("/(Đ)/", 'D', $str);
			$str = preg_replace("/(ł)/", 'l', $str);
			$str = preg_replace("/(Ł)/", 'L', $str);
			$str = preg_replace("/(Ń)/", 'n', $str);
			$str = preg_replace("/(ń)/", 'n', $str);
        	$str = preg_replace("/(Š|Ś)/", 'S', $str);
			$str = preg_replace("/(Ž|Ż|Ź)/", 'Z', $str);
		    $str = str_replace(" ", "-", str_replace("&*#39;","",$str));
		    $str = preg_replace('/[^A-Za-z0-9\-._]/', '', $str); // Removes special chars.
		    $str = preg_replace('/-+/', '-', $str);
		    $str = strtolower($str);
            return $str;
        }

		// Array replace: This will replace all variable in an array with its value in a string.
		function array_replace($string, $array){
			$return = $string;
			foreach($array as $key => $value) {
				$return = str_replace("{{".$key."}}", $value, $return);
			}
			return $return;
		}


		// redirect with javascript
		function redirect($url,$delay = ""){
			if($delay != NULL) { 
				echo '<script> setTimeout(\'window.location.href="'.$url.'"\', '.$delay.');</script>'; 
			}else{ 
				echo '<script> window.location.href="'.$url.'"; </script>';  
			}
		}

		// substr function for utf8 string
		function utf8Substr($str,$from,$len){
		return preg_replace('#^(?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){0,'.$from.'}'.
	                       '((?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){0,'.$len.'}).*#s',
	                       '$1',$str);
		}

	    function slugIsExist($slug){
			$this->db->limit_val = "1";
	        $result = $this->db->dbSelect($this->ninja_config['TABLES_PREFIX']."slug",array("s_id"),array("slug"=>$slug));
	        if(count($result) == '1'){
	            return true;
	        }
	        return false;
	    }

		// Get this page URL with port 
		function currentUrl() {
			$protocol = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') ? 'https' : 'http';
			$host     = $_SERVER['HTTP_HOST'];
			$script   = $_SERVER["REQUEST_URI"];
			 
			$currentUrl = $protocol . '://' . $host . $script;
			 
			return $currentUrl;
		}	

		// Remove the siteUrl and print the request page
		function requestPage($currentUrl, $params = 0){
			$currentUrl = preg_replace('#^(http(s)?://)?w{3}\.(\w+\.\w+)#', '$1', $currentUrl);
			$page_array = explode('?',$currentUrl);
			if (strpos($currentUrl,$this->ninja_config['siteUrl']) !== false) {
				$requestPage = ($params == '1') ? trim(str_replace($this->ninja_config['siteUrl'], '', $currentUrl)) : trim(str_replace($this->ninja_config['siteUrl'], '', $page_array['0']));
				return $requestPage;
			}
			$parseUrl = parse_url($currentUrl);
			preg_match('/^(?:(.+)\.)?([^.]+\.[^.]+)$/', $parseUrl['host'], $matches);
			return '/'.$matches[1];
		}

		function paginator($totalElement, $perPage, $currentPage = NULL){
			$return = array();
			if (!is_numeric($currentPage) || $currentPage < 1){ $currentPage = 1; }	
			$return['lastpage'] = ceil($totalElement/$perPage);				
			$return['prev'] = $currentPage == 1 ? '1' : $currentPage - 1;							
			$return['next'] = $currentPage >= $return['lastpage'] - 1 ? $return['lastpage'] : $currentPage + 1;	
			$return['start'] = (is_numeric($currentPage) ? ($currentPage - 1) * $perPage : 0);
			$return['currentPage'] = $currentPage;
			return $return;
		}

		// UP x level with URL example: input http://google.com/some/some up one level -> http://google.com/some/
		function upDir($url,$level){
			if(strpos($url, '.html') || strpos($url, '.php')){
				preg_match('/(.*).(php|html)(.*)/', $url, $matches);
				$url = $matches[1];
			}
			$url = explode('/',$url);
			$levels = count($url);
			for($i = 1; $i <= $level; $i++){
				unset($url[$levels-$i]);
			}
			$url = implode('/',$url);
			return $url;
		}

		// GET THE PAGE URL WITHOUT VARIABLE
		function currentUrlNoVar(){
			$thisPage = $this->currentUrl();
			$thisPageWithoutVariable = explode("?", $thisPage);
			return $thisPageWithoutVariable[0];
		}

		// DELETE DIR AND FILES
		public static function deleteDir($dirPath) {
		    if (! is_dir($dirPath)) {
		        throw new InvalidArgumentException("$dirPath must be a directory");
		    }
		    if (substr($dirPath, strlen($dirPath) - 1, 1) != '/') {
		        $dirPath .= '/';
		    }
		    $files = glob($dirPath . '*', GLOB_MARK);
		    foreach ($files as $file) {
		        if (is_dir($file)) {
		            self::deleteDir($file);
		        } else {
		            unlink($file);
		        }
		    }
		    rmdir($dirPath);
		}

		// CACHE SYSTEM 
		// CACHE SYSTEM 
		// CACHE SYSTEM 

		function cache($name){
			if (file_exists(ROOT_DIR.'/caches/'.$name.'.html') /*&& time() - 18000 < filemtime(ROOT_DIR.'/caches/'.$name.'.html')*/) { 
				include(ROOT_DIR.'/caches/'.$name.'.html'); 
				return true;
			}else{	
				ob_start();
				return false;
			}
		}

		function cacheEnd($name){
			$file = ROOT_DIR.'/caches/'.$name.'.html';
			chmod ($file, 0777);
			$cached = fopen($file, 'w');
			fwrite($cached, ob_get_contents()); 
			fclose($cached); 
			chmod ($file, 0644);
			ob_end_flush();
		}

		function cacheClear($name){
			if (file_exists(ROOT_DIR.'/caches/'.$name.'.html')) {
				unlink(ROOT_DIR.'/caches/'.$name.'.html');
			}
		}

		function alphaID($in, $to_num = false, $pad_up = false, $passKey = null){
		    $index = "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		    if ($passKey !== null){
		        for ($n = 0; $n<strlen($index); $n++){
		            $i[] = substr( $index,$n ,1);
		        }

		        $passhash = hash('sha256',$passKey);

		        $passhash = (strlen($passhash) < strlen($index)) ? hash('sha512',$passKey) : $passhash;

		        for ($n=0; $n < strlen($index); $n++){
		            $p[] =  substr($passhash, $n ,1);
		        }

		        array_multisort($p,  SORT_DESC, $i);
		        $index = implode($i);
		    }

		    $base  = strlen($index);

		    if ($to_num){
		        // Digital number  <<--  alphabet letter code
		        $in  = strrev($in);
		        $out = 0;
		        $len = strlen($in) - 1;

		        for ($t = 0; $t <= $len; $t++){
		        	if (function_exists('bcpow')){
		           	 	$bcpow = bcpow($base, $len - $t);
		        	}else{
						$bcpow = pow($base, $len - $t);
		        	}
		            $out   = $out + strpos($index, substr($in, $t, 1)) * $bcpow;
		        }

		        if (is_numeric($pad_up)){
		            $pad_up--;
		            if ($pad_up > 0)
		            {
		                $out -= pow($base, $pad_up);
		            }
		        }
		        $out = sprintf('%F', $out);
		        $out = substr($out, 0, strpos($out, '.'));
		    }else{
		        // Digital number  -->>  alphabet letter code
		        if (is_numeric($pad_up)){
		            $pad_up--;
		            if ($pad_up > 0)
		            {
		                $in += pow($base, $pad_up);
		            }
		        }

		        $out = "";
		        for ($t = floor(log($in, $base)); $t >= 0; $t--){
		        	if (function_exists('bcpow')){
		            	$bcp = bcpow($base, $t);
		        	}else{
		            	$bcp = pow($base, $t);
		        	}
		            $a   = floor($in / $bcp) % $base;
		            $out = $out . substr($index, $a, 1);
		            $in  = $in - ($a * $bcp);
		        }
		        $out = strrev($out); // reverse
		    }
		    return $out;
		}
		function build_param(array $current, array $change){
			$params = $_GET;
			$params = $current;
			foreach($change as $key => $value){
				$params[$key] = $value;
			}
			return http_build_query($params);

		}
		
        function excerpt($input, $len){
        	if(strlen($input) > $len){
	        	$end = strlen($input) > $len ? ' ...' : '';
	            $input = substr($input, 0, $len);
	            $pos = strrpos($input, " ");
	            $input = substr($input, 0, $pos);
	            $output = strip_tags($input).$end; 
	            return $output;
        	}
        	return $input;	
        }
		function stritr($string, $one = NULL, $two = NULL){
	        if(  is_string( $one )  ){
	            $two = strval( $two );
	            $one = substr(  $one, 0, min( strlen($one), strlen($two) )  );
	            $two = substr(  $two, 0, min( strlen($one), strlen($two) )  );
	            $product = strtr(  $string, ( strtoupper($one) . strtolower($one) ), ( $two . $two )  );
	            return $product;
	        }
	        else if(  is_array( $one )  ){
	            $pos1 = 0;
	            $product = $string;
	            while(  count( $one ) > 0  ){
	                $positions = array();
	                foreach(  $one as $from => $to  ){
	                    if(   (  $pos2 = stripos( $product, $from, $pos1 )  ) === FALSE   ){
	                        unset(  $one[ $from ]  );
	                    }
	                    else{
	                        $positions[ $from ] = $pos2;
	                    }
	                }
	                if(  count( $one ) <= 0  )break;
	                $winner = min( $positions );
	                $key = array_search(  $winner, $positions  );
	                $product = (   substr(  $product, 0, $winner  ) . $one[$key] . substr(  $product, ( $winner + strlen($key) )  )   );
	                $pos1 = (  $winner + strlen( $one[$key] )  );
	            }
	            return $product;
	        }
	        else{
	            return $string;
	        }
	    }
		function array_value_recursive($key, array $arr){
		    $val = array();
		    array_walk_recursive($arr, function($v, $k) use($key, &$val){
		        if($k == $key) array_push($val, $v);
		    });
		    return count($val) > 1 ? $val : array_pop($val);
		}
		function config_file_add($config_file, $array_new_value){
			$old_file = json_decode(file_get_contents($config_file), true);
			$new_file = array_merge($old_file, $array_new_value);
			if (!is_writable($config_file)) {
				chmod($config_file, 0777);
				$return['status'] = 0;
				$return['info'] = $config_file.' is not writable';
				return $return;
			}else{	
				file_put_contents($config_file, json_encode($new_file));
				$return['status'] = 1;
				$return['info'] = 'Done';
				return $return;
			}
		}
		function locale_file_add($application, $array_new_value){
			if ($handle = opendir(ROOT_DIR.'/ninja-applications/'.$application.'/locales/')) {
                while (false !== ($entry = readdir($handle))) {
					if ($entry != "." && $entry != "..") {
                       $do_add = $this->config_file_add(ROOT_DIR.'/ninja-applications/'.$application.'/locales/'.$entry, $array_new_value);
                       if($do_add['status'] == '0'){
							$return['status'] = 0;
							$return['info'] = $do_add['info'];
							return $return;
                       }
                    }
                }
                closedir($handle);
            }
			$return['status'] = 1;
			$return['info'] = 'Done';
			return $return;
		}
		function writeConfig( $filename, $config ) {
			@chmod($filename, 0777);
		    $fh = fopen($filename, "w");
		    if (!is_resource($fh)) {
		        return false;
		    }
		    fwrite($fh, json_encode($config));
		    fclose($fh);
			@chmod($filename, 0755);
		    return true;
		}
	}

?>