<?php

	ob_start();
	session_start();
	error_reporting(E_ALL ^ E_NOTICE);

	/* DEFINE ROOT DIR */
	define( 'ROOT_DIR', realpath(dirname(__FILE__) . '/..') );

	/* SPECIFIC ERROR LOG FILE */
	@ini_set("log_errors" , "1");
	@ini_set("error_log" , ROOT_DIR.'/ninja-error.log');
	@ini_set("display_errors" , "0");

	/* INCLUDE IMPORTANT FILES*/
	$ninja_config = json_decode(file_get_contents(ROOT_DIR.'/ninja-configs/config.ninja.inc'), true);
	$ninja_admin = json_decode(file_get_contents(ROOT_DIR.'/ninja-configs/config.ninja-admin.inc'), true);
	$mailer_config = json_decode(file_get_contents(ROOT_DIR.'/ninja-configs/config.mailer.inc'), true);
	$ninja_config = array_merge($ninja_config, json_decode(file_get_contents(ROOT_DIR.'/ninja-configs/config.db.inc'), true));


	/*	Include classes */
	require ROOT_DIR.'/ninja-classes/PHPMailerAutoload.php';
	require ROOT_DIR.'/ninja-classes/class.db.php';
	require ROOT_DIR.'/ninja-classes/class.ninja.php';

	/*  Calling object */
	$ninja = new ninja($ninja_config);

	/* INCLUDE APPLICATIONS's CONTROLLERS */
	
	$lang = array();

	// ADD USER CONTROLLERS
	if(file_exists(ROOT_DIR.'/ninja-applications/user/controllers/cont.init.php')){
		include ROOT_DIR.'/ninja-applications/user/controllers/cont.init.php';
	}

	if(isset($ninja_config['applications'])){
		foreach($ninja_config['applications'] as &$value){
			// INCLUDE MAIN CONTROLLERS
			if(!file_exists(ROOT_DIR.'/ninja-applications/'.$value.'/install')){
			 include ROOT_DIR.'/ninja-applications/'.$value.'/controllers/cont.init.php';
			}
		}
	}

	/*  Generate TOKEN for whole FORM */
	$_SESSION['token'] = '';

	/* OTHERS */

	date_default_timezone_set($ninja_config['timezone']);
	$now = date("Y-m-d H:i:s");
